;
;  list_add
;  list_kill
;  list_get
;  list_swap
;  list_getmax
;



list_header 	struc
		list_first		dd		?
		list_last		dd		?
;-----------------------------------------------------------------------------
ifndef DYNAMIC_LIST

		list_mem		dd		?
		list_bufer		dd		?
endif
;-----------------------------------------------------------------------------
		ends


;
;LIST_ADD
;
;IN:	EBX=list descriptor
;	EDX=position (FFFFFFFFh if elementh is added to end)
;		     (0 if  first)	
;	EDI=offset to data
;
list_add:
                pusha


;-----------------------------------------------------------------------------
ifdef DYNAMIC_LIST
                push SIZE one                           ;	
		call m__malloc                          ; create element
		add esp,4                               ;
		xchg esi,eax				;
else
;-[Static]--------------------------------------------------------------------
		lea esi,[ebx.list_bufer]		;esi=list_bufer
		opzmov ecx,<SIZE one>

ladd_lookup_empty:

		cmp esi,[ebx.list_mem]			;last in heap?
                je ladd_chain
                                                       
		mov eax,[esi.one_next]			;next = FFFFFFFFh?
		inc eax					;      
                jz ladd_insert

                add esi,ecx				; size one
                jmp ladd_lookup_empty

ladd_chain:
                add 4 ptr[ebx.list_mem],ecx		; size one
endif
;-----------------------------------------------------------------------------


;
ladd_insert:

		;EDI=DATA
		;ESI=MEMORY for new elementh

		push esi
		xchg edi,esi                            ; ESI=src EDI=bufer
		lea edi,[edi.one_data]
                opzmov ecx,ONEDATA_SIZE
                rep movsb				; copy data
                pop esi

                ;REP  ECX=0
		
		cmp [ebx.list_first],ecx		; first = 0?
		jne ladd_0000_add

;-[first in list]------------------------------------------------------------

		mov [ebx.list_last],esi
;		mov [ebx.list_first],esi
		jmp ladd_0000_exit

;-[at begin?]----------------------------------------------------------------
ladd_0000_add:	
		or edx,edx				; add first?
        	jnz ladd_some_add                       ;
		
		mov eax,[ebx.list_first]

                ;EDX = 0
		mov [esi.one_prev],edx			; prev=0
		mov [esi.one_next],eax			; next=prev_first
                mov [eax.one_prev],esi			; prev_first.prev=new_first


ladd_0000_exit:
		mov [ebx.list_first],esi
		jmp ladd_exit

;-[some elementh]------------------------------------------------------------
ladd_some_add:

		;EDX=elementh number(1  FFFFFFFFh)
                mov edi,[ebx.list_first]

ladd_find_need_num:
		cmp edi,[ebx.list_last]
		je ladd_last

		dec edx					; needed?
                jz ladd_link

		mov edi,[edi.one_next]
		jmp ladd_find_need_num

;----------------------------------------------------------------------------
ladd_last:
		mov [esi.one_prev],edi                  ; prev=prev_last
		mov [edi.one_next],esi			; prev_last.next=new_last

		xor eax,eax                             ; next=0
		mov [esi.one_next],eax			;	******

		mov [ebx.list_last],esi
		jmp ladd_exit

;----------------------------------------------------------------------------
ladd_link:

                mov eax,[edi.one_next]

		mov [esi.one_next],eax
		mov [esi.one_prev],edi

		mov [eax.one_prev],esi
		mov [edi.one_next],esi

ladd_exit:
                popa
                ret

;
;LIST_KILL
;
;IN:	EBX=list_desctiptor
;	EDX=position (FFFFFFFF if killed elem is last)
;		     (1 if first)
;

list_kill:
                pusha


		mov edi,[ebx.list_first]

		xor ecx,ecx                             ; ECX = 0

		dec edx                                 ;
		jz lkill_first                          ; first ?
		inc edx					;

;----------------------------------------------------------------------------
lkill_some:
                cmp edi,[ebx.list_last]
		je lkill_last

		dec edx
		jz lkill_link

                mov edi,[edi.one_next]
                jmp lkill_some

;----------------------------------------------------------------------------
lkill_first:

		mov eax,[edi.one_next]
		mov [ebx.list_first],eax

		mov [eax.one_prev],ecx			; = 0
		jmp lkill_free

;----------------------------------------------------------------------------
lkill_last:
		mov eax,[edi.one_prev]
		mov [ebx.list_last],eax

		mov [eax.one_next],ecx                  ; = 0
		jmp lkill_free

;----------------------------------------------------------------------------
lkill_link:

		mov edx,[edi.one_next]
		mov eax,[edi.one_prev]

                mov [eax.one_next],edx
                mov [edx.one_prev],eax

lkill_free:
;-----------------------------------------------------------------------------
ifdef DYNAMIC_LIST
		push edi 				;
		call m__free                            ; release memory
		add esp,4                               ;
else
;-[Static]--------------------------------------------------------------------
		dec ecx					; ECX = FFFFFFFF
                mov [edi.one_next],ecx                  ; free flag
                mov [edi.one_prev],ecx                  ; free flag
endif
;-----------------------------------------------------------------------------

                popa
                ret


;
;LIST_GET
;
;In	:	EBX=list descriptor
;		EDX=position (1FFFFFFFF)
;Out 	: 	EAX=elementh adr
;
list_get:
                pusha

		mov esi,[ebx.list_first]
lg_find:
		dec edx
		jz lg_get

		cmp esi,[ebx.list_last]			;list_last?
		je lg_get

                mov esi,[esi.one_next]
                jmp lg_find
lg_get:
		mov [esp._eax],esi			;esi=adress
                popa
                ret


;
;LIST SWAP
;
;In:	EBX = list descriptor
;       EDX = elementh #1
;       ECX = elementh #2
;
list_swap:
                pusha

		mov ebp,ONEDATA_SIZE			; stack bufer
		sub esp,ebp
		mov edi,esp

		;EDX=num
		;EBX=listd
		call list_get				; ECX=#1 Adr
		xchg eax,ecx				;

		xchg edx,eax
		call list_get				; EBX=#2 Adr
		xchg ebx,eax				;
		xchg edx,ecx				; EDX=#1 Adr

		push edi
		lea esi,[edx.one_data]			;
		mov ecx,ebp		                ;
		rep movsb                               ; #1  bufer

		lea edi,[edx.one_data]			;
		lea esi,[ebx.one_data]			;
		mov ecx,ebp				;
		rep movsb                               ; #2  #1

		pop esi
							; ESI=bufer
		lea edi,[ebx.one_data]     		; EDI=#2
		mov ecx,ebp				;
		rep movsb                               ; bufer  #2 

		add esp,ebp
		popa
		ret

;
;LIST GETMAX
;
;IN: 		EBX=list
;OUT:		EAX=elem. count
;
list_getmax:
                pusha

		mov esi,[ebx.list_first]

                xor eax,eax
		inc eax
lgm_next:
                cmp esi,[ebx.list_last]
		je lgm_exit

                inc eax
                mov esi,[esi.one_next]
                jmp lgm_next
lgm_exit:

		mov [esp._eax],eax
                popa
                ret
